package ru.dbotthepony.kstarbound.player

import com.google.gson.JsonArray
import com.google.gson.JsonElement
import com.google.gson.JsonObject
import org.apache.logging.log4j.LogManager
import ru.dbotthepony.kstarbound.Registries
import ru.dbotthepony.kstarbound.Starbound
import ru.dbotthepony.kstarbound.defs.quest.QuestTemplate
import ru.dbotthepony.kstarbound.lua.NewLuaState
import ru.dbotthepony.kstarbound.item.ItemStack
import ru.dbotthepony.kommons.gson.set
import ru.dbotthepony.kstarbound.defs.quest.QuestDescriptor
import java.util.HashMap
import java.util.UUID

class QuestInstance(
	val avatar: Avatar,
	val descriptor: QuestDescriptor,
	val seed: Long = System.nanoTime().rotateLeft(27).xor(System.currentTimeMillis()),
	val serverID: UUID? = null,
	val worldID: String? = null
) {
	val template: QuestTemplate = Registries.questTemplates[descriptor.templateId]?.value ?: throw IllegalArgumentException("No such quest template ${descriptor.templateId}")
	val id get() = descriptor.questId

	val lua = NewLuaState()

	enum class State(val serializedName: String) {
		NEW("New"),
		OFFER("Offer"),
		ACTIVE("Active"),
		COMPLETE("Complete"),
		FAILED("Failed")
	}

	private val objectiveList = ArrayList<Pair<String, Boolean>>()

	var canTurnIn = false
	var failureText = ""
	var completionText = ""
	var text = ""
	var title = ""
	var state = State.NEW
	var progress: Double? = null
	var compassDirection: Double? = null

	private val portraits = JsonObject()
	//private val params = descriptor.parameters.deepCopy()

	private val portraitTitles = HashMap<String, String>()

	private var isInitialized = false
	private var successfulInit = false
	private var calledStart = false
	private var successfulStart = false

	private val rewards = ArrayList<ItemStack>()

	fun complete() {

	}

	fun fail() {

	}

	private fun setObjectiveList(value: JsonArray) {

	}

	private fun addReward(value: JsonElement) {
		val item = Starbound.item(value)

		if (!item.isEmpty) {
			rewards.add(item)
		}
	}

	init {
		//for ((k, v) in descriptor.parameters.entrySet()) {
		//	params[k] = v.deepCopy()
		//}
	}

	companion object {
		private val LOGGER = LogManager.getLogger()
	}
}
